@import './includes/sass_vars_and_mixins.module.scss';

// Base wrapper to create spacing between screen and content without max width
.wrapper {
  margin-left: var(--space-m);
  margin-right: var(--space-m);

  @include smaller-than-s {
    margin-left: 0;
    margin-right: 0;
  }
}

%container {
  margin: 0 auto;
  max-width: calc(var(--size-max-content-width) + (var(--space-xxxl) * 2));
  padding-left: var(--space-xxxl);
  padding-right: var(--space-xxxl);

  .grid {
    padding-right: 0;
    padding-left: 0;
    grid-column: main-start / main-end;
  }

  &.centerHorizontal {
    text-align: center;
  }

  &.centerVertical {
    align-items: center;
  }

  .alignBottom {
    align-items: end;
  }

  @include smaller-than-l {
    padding-left: var(--space-l);
    padding-right: var(--space-l);
  }

  @include smaller-than-s {
    padding-left: var(--space-m);
    padding-right: var(--space-m);

    &.preventMobileOverflow {
      overflow-x: hidden;
    }

    &.sFull {
      padding-left: 0;
      padding-right: 0;
    }
  }
}

// general container without grid behavior
.container {
  @extend %container;
}

// base grid
.grid {
  @extend %container;
  display: grid;
  grid-template-columns:
    [main-start] repeat(12, minmax(0, 200px) [col-start])
    [main-end];

  column-gap: var(--space-xl);

  @include smaller-than-l {
    column-gap: var(--space-l);
  }

  @include smaller-than-s {
    grid-template-columns:
      [main-start] minmax(0, auto)
      [main-end];
  }
}

// COLUMNS

.tile {
  margin-left: calc(-1 * var(--space-l));
  margin-right: calc(-1 * var(--space-l));
  padding: var(--space-l);

  @include smaller-than-xs {
    margin: 0;
    padding: var(--space-s);
  }
}

@for $i from 1 through 12 {
  .col#{$i} {
    grid-column-end: span $i;
  }
}

.colCenterHorizontal {
  justify-self: center;
}

.colAlignLeft {
  justify-self: start;
}

.colAlignRight {
  justify-self: end;
}

.colAlignBottom {
  align-self: end;
}

@for $i from 1 through 4 {
  .textCol#{$i} {
    columns: $i;
    column-gap: var(--space-xl);

    @include smaller-than-l {
      column-gap: var(--space-l);
    }

    @include smaller-than-s {
      columns: 1;
    }
  }
}

@for $i from 0 through 12 {
  .offset#{$i} {
    grid-column-start: col-start $i;
  }
}

@include smaller-than-l {
  @for $i from 1 through 12 {
    .lCol#{$i} {
      grid-column-end: span $i;
    }
  }

  .lOffset0 {
    grid-column-start: main-start;
  }

  .lCenterHorizontal {
    justify-self: center;
  }

  .lAlignLeft {
    justify-self: start;
  }

  .lAlignRight {
    justify-self: end;
  }

  @for $i from 0 through 12 {
    .lOffset#{$i} {
      grid-column-start: col-start $i;
    }
  }
}

@include smaller-than-m {
  @for $i from 1 through 12 {
    .mCol#{$i} {
      grid-column-end: span $i;
    }
  }

  .mOffset0 {
    grid-column-start: main-start;
  }

  .mColCenterHorizontal {
    justify-self: center;
  }

  .mColAlignLeft {
    justify-self: start;
  }

  .mColAlignRight {
    justify-self: end;
  }

  @for $i from 1 through 12 {
    .mOffset#{$i} {
      grid-column-start: col-start $i;
    }
  }
}

@include smaller-than-s {
  @for $i from 1 through 12 {
    .col#{$i},
    .lCol#{$i},
    .mCol#{$i} {
      grid-column: main-start / main-end;
    }
  }

  @for $i from 0 through 12 {
    .offset#{$i},
    .lOffset#{$i},
    .mOffset#{$i} {
      grid-column-start: main-start;
    }
  }

  .sColCenterHorizontal {
    justify-self: center;
  }

  .sColAlignLeft {
    justify-self: start;
  }

  .sColAlignRight {
    justify-self: end;
  }
}

// DEBUG
.debug {
  height: 50px;
  background-color: rgba(255, 80, 130, 0.3);
  display: flex;
  align-items: center;
  padding: 0 var(--space-s);
  position: relative;
  color: red;
  box-shadow: inset 0 0 0 1px rgba(red, 0.5);

  &:before {
    content: 'XL';
    position: absolute;
    top: 2px;
    right: 3px;
    font-size: var(--font-size-xs);
  }

  @include smaller-than-l {
    &:before {
      content: 'L';
    }
  }

  @include smaller-than-m {
    &:before {
      content: 'M';
    }
  }

  @include smaller-than-s {
    &:before {
      content: 'S';
    }
  }

  @include smaller-than-xs {
    &:before {
      content: 'XS';
    }
  }
}
